
// gtracedlg.h

#ifndef _GTRACEDLG_H_
#define _GTRACEDLG_H_



typedef struct tagTraceFilter
{
   LPCTSTR lpszDesc;
   DWORD dwValue;

} TRACEFILTER, *LPTRACEFILTER;



// this dialog can be displayed in release or debug, and provides     
// an easy way to change the GTRACE registry settings
class GTraceSettingsDlg : public CDialog
{
   DECLARE_MESSAGE_MAP()

public:
   GTraceSettingsDlg(CWnd* pParent=NULL);

   int DoModal(LPTRACEFILTER lpFilters, int nCount);                

protected:
   // DDX/DDV support
   virtual void DoDataExchange(CDataExchange* pDX);   
   virtual BOOL OnInitDialog();

protected:
   // class members mapped to control data...
   BOOL m_bCheckEnable;
   BOOL m_bCheckExcludeArgs;
   BOOL m_bCheckFunctionTimings;
   BOOL m_bCheckDebug;
   CString m_strEditFileName;

   // subclass for list box 
   CCheckListBox m_listboxFilter;
   // pointer to trace filters
   LPTRACEFILTER m_lpTraceFilters;
   // number of filters
   int m_nFilterCount;

   // enable/disable controls associated with specifying an output 
   // file name
   void EnableOutputFile(BOOL bEnable);
   // enable/disable all controls (except main checkbox)
   void EnableAll(BOOL bEnable);

   afx_msg void OnButtonBrowse();
   afx_msg void OnCheckTrace();
   afx_msg void OnCheckFunctimings();
   afx_msg void OnCheckEnable();
};


#endif
